#include <stdio.h>
#include "ntport.h"
#include "lthread.h"


#ifdef NT_PTHREADS

int pthread_attr_init( pthread_attr_t *attr ){return( 0 );}
int pthread_attr_destroy( pthread_attr_t *attr ){return( 0 );}
int pthread_attr_setdetachstate( pthread_attr_t *attr, int detachstate ){return( 0 );}
int pthread_attr_getdetachstate( pthread_attr_t *attr, int *detachstate ){return( 0 );}
int pthread_mutex_trylock( pthread_mutex_t *mtex ){	return 0;}
void pthread_exit(){ _endthreadex(0);}


int pthread_create(pthread_t *tid, pthread_attr_t attr, LPTHREAD_START_ROUTINE func, LPVOID arg)
{
	if ( ( (unsigned long) *tid = _beginthreadex( NULL, 0, func, (LPVOID) arg, 0, NULL )) == -1 )
		return 1;
	else 
		return( 0 );
	
}


void pthread_join( pthread_t tid, int *status )
{
	if ( (WaitForSingleObject(tid, INFINITE) != WAIT_OBJECT_0) )
		return;
	else
		return;
}


int pthread_mutex_init( pthread_mutex_t *mtex, pthread_mutexattr_t *attr )
{
	if ( (*mtex = CreateMutex(NULL, FALSE, NULL)) == NULL )
		return 1;
	else
		return 0;
}


int pthread_mutex_destroy( pthread_mutex_t *mtex )
{
	if ( !(CloseHandle(*mtex)) )
		return 1;
	else
		return 0;
}


int pthread_mutex_lock( pthread_mutex_t *mtex )
{
	if ( (WaitForSingleObject(*mtex, INFINITE) != WAIT_OBJECT_0) )
		return 1;
	else
		return 0;
}



int pthread_mutex_unlock( pthread_mutex_t *mtex)
{
	if ( !(ReleaseMutex(*mtex)) )
		return 1;
	else
		return 0;
}





int pthread_cond_init( pthread_cond_t *cv, pthread_condattr_t *attr )
{
	if ((*cv = CreateEvent(NULL, FALSE, /*TRUE*/ FALSE, NULL)) == NULL)
		return 1; // Error
	else
		return 0; // Success
}



int pthread_cond_destroy( pthread_cond_t *cv )
{
	if ( !(CloseHandle( *cv )) )
		return 1;
	else
		return 0;
}



int pthread_cond_wait( pthread_cond_t *cv, pthread_mutex_t *mp )
{
	int rc=WaitForSingleObject(*cv, INFINITE);
	return 0;
}


int pthread_cond_signal( pthread_cond_t *cv )
{
	if ( !(SetEvent( *cv )) )
		return 1;
	else
		return 0;
}

#endif /* nt implementation */
